Index: trunk/NVTK/INSTALL/JOBS/assessment.ksh
===================================================================
--- trunk/NVTK/INSTALL/JOBS/assessment.ksh	(revision 1365)
+++ trunk/NVTK/INSTALL/JOBS/assessment.ksh	(revision 1564)
@@ -77,7 +77,25 @@
 touch endjob.txt
 
+if [ ${CONF} == 'ORCA2_LIM' ] ; then
+    CONFS=ORCA2
+elif [ ${CONF} == 'ORCA2_LIM3' ] ; then
+    CONFS=OR2L3
+elif [ ${CONF} == 'GYRE' ] ; then
+    CONFS=GYREO
+elif [ ${CONF} == 'GYRE_LOBSTER' ] ; then
+    CONFS=GYREL
+elif [ ${CONF} == 'ORCA2_LIM_PISCES' ] ; then
+    CONFS=OR2LP
+elif [ ${CONF} == 'ORCA2_OFF_PISCES' ] ; then
+    CONFS=OR2OP
+elif [ ${CONF} == 'ZAGRIF' ] ; then
+    CONFS=ZAGRI
+else
+    CONFS=${CONF}
+fi
+
 ###########################################################
 # checkfile() is a local function to check if a file exist
-# 2 arguments:
+# 5 arguments:
 #    - zf2check : file name to check
 #    - zoutfile : output file name to print results
@@ -359,16 +377,35 @@
 # 0.I LIST OF FILES TESTED, i.e. stored under NVTK/2TEST directory
 # ###############################
-nbfiles=$( (cat f2test.txt | wc -l) )
 echo " #################################################      " >> endjob.txt
-echo " FILES STORED UNDER NVTK/2TEST DIRECTORY & TESTED       " >> endjob.txt
+echo " FILES STORED UNDER NVTK/${EXPER} DIRECTORY & TESTED    " >> endjob.txt
 echo " #################################################      " >> endjob.txt
 echo "                                                        " >> endjob.txt
-echo "   Number of files : ${nbfiles}                         " >> endjob.txt
-echo "                                                        " >> endjob.txt
-cat f2test.txt                                                  >> endjob.txt
-echo "                                                        " >> endjob.txt
-
-# ###############################
-# 0.II NEMO SOURCE FILES INFORMATION, i.e. revision & URL downloaded
+LSFILES=`head -1 f2test.txt | wc -w`
+if [ $LSFILES != 0 ] ; then
+    for file in `head -1 f2test.txt` ; do 
+        echo "   -" $file                                       >> endjob.txt
+    done
+else
+    echo "                                                    " >> endjob.txt
+    echo "   ---> NO files tested                             " >> endjob.txt
+    echo "                                                    " >> endjob.txt
+fi
+echo "                                                        " >> endjob.txt
+
+# ###############################
+# 0.II LIST OF CPP KEYS USED
+# ###############################
+echo " #################################################      " >> endjob.txt
+echo " CPP KEYS USED FOR ${EXPER} EXPERIENCE                   " >> endjob.txt
+echo " #################################################      " >> endjob.txt
+echo "                                                        " >> endjob.txt
+for file in `tail -1 f2test.txt` ; do 
+    echo "   -" $file                                           >> endjob.txt
+done
+echo "                                                        " >> endjob.txt
+
+# ###############################
+# ###############################
+# 0.III NEMO SOURCE FILES INFORMATION, i.e. revision & URL downloaded
 # ###############################
 echo " #############################                          " >> endjob.txt
@@ -379,10 +416,9 @@
 echo "   NEMO revision : ${REV_USE}                           " >> endjob.txt
 echo "                                                        " >> endjob.txt
-echo "                                                        " >> endjob.txt
 
 
 test -n "${TODO}"
 id2do=$?
-if [ ${id2do} == 0 -a ${TARGET} = 'aix6' ] ; then concat_perf ${CONF} ; fi
+if [ ${id2do} == 0 -a ${TARGET} = 'aix6' ] ; then concat_perf ${CONFS} ; fi
 
 #@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@ -391,6 +427,6 @@
 # I. CHECK EXECUTABLE MEMORY SIZE
 # ###############################
-filecs="mon/LONG/${EXPER}/memory_size.txt" ;  filers='mon/LONG/REF/memory_size.txt'
-filecm="mon/LONG/${EXPER}/mon${CONF}_err"  ;  filerm="mon/LONG/REF/mon${CONF}_err"
+filecs="mon/LONG/${EXPER}/memory_size.txt" ;  filers="mon/LONG/${REF_TAG}/memory_size.txt"
+filecm="mon/LONG/${EXPER}/mon${CONFS}_err"  ;  filerm="mon/LONG/${REF_TAG}/mon${CONFS}_err"
 xfilecs=0  ; xfilecm=0 ; xfilers=0 ; xfilerm=0
 echo " ############################                           " >> endjob.txt
@@ -408,7 +444,7 @@
 
     if [ ${REF_TAG} ] ; then 
-        ./MEM_size_${TARGET}.ksh -a ${xfilecm} -b ${xfilers} -d ${xfilerm} -e ${EXPER} -c ${CONF} -o endjob.txt -t ${REF_TAG} 
+        ./MEM_size_${TARGET}.ksh -a ${xfilecm} -b ${xfilers} -d ${xfilerm} -e ${EXPER} -c ${CONFS} -o endjob.txt -t ${REF_TAG} 
     else
-        ./MEM_size_${TARGET}.ksh -a ${xfilecm} -b ${xfilers} -d ${xfilerm} -e ${EXPER} -c ${CONF} -o endjob.txt
+        ./MEM_size_${TARGET}.ksh -a ${xfilecm} -b ${xfilers} -d ${xfilerm} -e ${EXPER} -c ${CONFS} -o endjob.txt
     fi
 
@@ -443,9 +479,9 @@
 
         # Check that timing file for the ${runt} current version exist
-        filecv="${runt}/GTIME/${EXPER}/${runt}${CONF}_err" 
+        filecv="${runt}/GTIME/${EXPER}/${runt}${CONFS}_err" 
         checkfile ${filecv} 'endjob.txt' NORM yes ; xfilecv=$?
 
         # Check that timing file for the ${runt} reference version exist
-        filerv="${runt}/GTIME/REF/${runt}${CONF}_err" 
+        filerv="${runt}/GTIME/${REF_TAG}/${runt}${CONFS}_err" 
         checkfile ${filerv} 'endjob.txt' NORM no ; xfilerv=$?
         echo "                                                             " >> endjob.txt
@@ -453,7 +489,7 @@
         if [ ${xfilecv} == 0 ] ; then 
             if [ ${REF_TAG} ] ; then 
-                ./CPU_time_${TARGET}.ksh -r ${runt} -a ${filecv} -b ${filerv} -c ${CONF} -o endjob.txt -x ${xfilerv} -t ${REF_TAG} 
+                ./CPU_time_${TARGET}.ksh -r ${runt} -a ${filecv} -b ${filerv} -o endjob.txt -x ${xfilerv} -t ${REF_TAG} 
             else
-                ./CPU_time_${TARGET}.ksh -r ${runt} -a ${filecv} -b ${filerv} -c ${CONF} -o endjob.txt -x ${xfilerv}
+                ./CPU_time_${TARGET}.ksh -r ${runt} -a ${filecv} -b ${filerv} -o endjob.txt -x ${xfilerv}
             fi
         fi
@@ -614,7 +650,7 @@
 
         file1="${runt}/1_SHORT/${EXPER}/solver.stat"          ;  file2="${runt}/2_SHORT/${EXPER}/solver.stat"
-        filev1="${runt}/1_SHORT/REF/solver.stat"              ;  filev2="${runt}/2_SHORT/REF/solver.stat"
+        filev1="${runt}/1_SHORT/${REF_TAG}/solver.stat"              ;  filev2="${runt}/2_SHORT/${REF_TAG}/solver.stat"
         file_oc1="${runt}/1_SHORT/${EXPER}/ocean.output"      ;  file_oc2="${runt}/2_SHORT/${EXPER}/ocean.output"
-        file_roc1="${runt}/1_SHORT/REF/ocean.output"          ;  file_roc2="${runt}/2_SHORT/REF/ocean.output"
+        file_roc1="${runt}/1_SHORT/${REF_TAG}/ocean.output"          ;  file_roc2="${runt}/2_SHORT/${REF_TAG}/ocean.output"
         xfilev1=0 ; xfilev2=0 ; xfile_oc1=0 ; xfile_oc2=0
 