Index: /trunk/NVTK/INSTALL/CONFIG_FILES/AA_make
===================================================================
--- /trunk/NVTK/INSTALL/CONFIG_FILES/AA_make	(revision 1573)
+++ /trunk/NVTK/INSTALL/CONFIG_FILES/AA_make	(revision 1574)
@@ -34,5 +34,5 @@
 #-Q- osxxlf	cp ../NVTK/INSTALL/JOBS/CPU_time_osxxlf.ksh  $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/CPU_time_osxxlf.ksh
 #-Q- osxxlf	cp ../NVTK/INSTALL/JOBS/MEM_size_osxxlf.ksh  $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/MEM_size_osxxlf.ksh
-	( cd $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/$@/ ; ./lance_batch.ksh $(NEMOLIB) $(MKTE) $(JOB) $(REXP) $(RTG) $(USE_IOMPUT) $(USE_IOSERVER) $(NB_PROCS_IOSERVER) ; )
+	( cd $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/$@/ ; ./lance_batch.ksh $(NEMOLIB) $(MKTE) $(JOB) $(REXP) $(MPIIJ) $(RTG) $(USE_IOMPUT) $(USE_IOSERVER) $(NB_PROCS_IOSERVER) ; )
 endif
 
@@ -58,5 +58,5 @@
 #-Q- sx8mercure	cp ../NVTK/INSTALL/JOBS/CPU_time_sx8mercure.ksh  $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/CPU_time_sx8mercure.ksh
 #-Q- sx8mercure	cp ../NVTK/INSTALL/JOBS/MEM_size_sx8mercure.ksh  $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/MEM_size_sx8mercure.ksh
-	( cd $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/$@/ ; ./lance_batch.ksh $(NEMOLIB) $(MKTE) $(JOB) $(REXP) $(RTG) $(USE_IOMPUT) $(USE_IOSERVER) $(NB_PROCS_IOSERVER) ; )
+	( cd $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/$@/ ; ./lance_batch.ksh $(NEMOLIB) $(MKTE) $(JOB) $(REXP) $(MPIIJ) $(RTG) $(USE_IOMPUT) $(USE_IOSERVER) $(NB_PROCS_IOSERVER) ; )
 endif
 
@@ -67,5 +67,11 @@
 mpi: memo
 ifeq ($(filter mpi,$(RUN)),mpi)
-	cp ./MY_SRC/par_oce.F90_keep ./MY_SRC/par_oce.F90 
+	@( cd MY_SRC ; \
+        grep -h jpni  * | grep -v "*" | head -1 > $$ ; VAR_I=`( cat $$ )` ; rm -f $$ ;\
+        grep -h jpnj  * | grep -v "*" | head -1 > $$ ; VAR_J=`( cat $$ )` ; rm -f $$ ;\
+        grep -h jpnij * | grep -v "*" | head -1 > $$ ; VARIJ=`( cat $$ )` ; rm -f $$ ;\
+        sed -e "s%$$VAR_I%      jpni  = $$MPI_I  , \&%" \
+            -e "s%$$VAR_J%      jpnj  = $$MPI_J  , \&%" \
+            -e "s%$$VARIJ%      jpnij = $$MPIIJ      %" par_oce.F90_keep > par_oce.F90 ; )
 	gmake -C WORK COMP=$@ EXPER=$(REXP) USE_IOMPUT=$(USE_IOMPUT) clean > $(NEMOLIB)_logbook_$@.txt
 	gmake -C WORK COMP=$@ EXPER=$(REXP) USE_IOMPUT=$(USE_IOMPUT) >> $(NEMOLIB)_logbook_$@.txt
@@ -94,5 +100,5 @@
 #-Q- osxxlf	cp ../NVTK/INSTALL/JOBS/CPU_time_osxxlf.ksh  $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/CPU_time_osxxlf.ksh
 #-Q- osxxlf	cp ../NVTK/INSTALL/JOBS/MEM_size_osxxlf.ksh  $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/MEM_size_osxxlf.ksh
-	( cd $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/$@/ ; ./lance_batch.ksh $(NEMOLIB) $(MKTE) $(JOB) $(REXP) $(RTG) $(USE_IOMPUT) $(USE_IOSERVER) $(NB_PROCS_IOSERVER) ; )
+	( cd $(WWDIR)/NEMO_VALID/W$(NEMOLIB)/$@/ ; ./lance_batch.ksh $(NEMOLIB) $(MKTE) $(JOB) $(REXP) $(MPIIJ) $(RTG) $(USE_IOMPUT) $(USE_IOSERVER) $(NB_PROCS_IOSERVER) ; )
 endif
 
Index: /trunk/NVTK/INSTALL/CONFIG_FILES/AA_make.ldef
===================================================================
--- /trunk/NVTK/INSTALL/CONFIG_FILES/AA_make.ldef	(revision 1573)
+++ /trunk/NVTK/INSTALL/CONFIG_FILES/AA_make.ldef	(revision 1574)
@@ -11,4 +11,7 @@
 NEMOLIB := $(shell awk '{ print $$1 }' ./WORK/.config)
 RUN=
+MPI_I=
+MPI_J=
+MPIIJ=
 JOB=
 RTG=
Index: /trunk/NVTK/INSTALL/JOBS/assessment.ksh
===================================================================
--- /trunk/NVTK/INSTALL/JOBS/assessment.ksh	(revision 1573)
+++ /trunk/NVTK/INSTALL/JOBS/assessment.ksh	(revision 1574)
@@ -9,6 +9,5 @@
 # configuration are finished 
 #
-# INPUT ARGS: 1 + 1 optional
-#     - CONF: configuration name (ORCA2_LIM, GYRE ..)
+# INPUT ARGS: 1 optional
 #     - TODO: (optional) Arg=yes or empty to build 
 #             output files including timing results. 
@@ -62,9 +61,12 @@
 #set -xv 
 ###########################################################
-CONF=$1
+CONF=`basename $( pwd ) | cut -c2-`
 TODO=$2
 TARGET=sx8brodie
 EXPER=$( ( awk '/test=/ { print $2 }' specifs.txt ) )
 LRTYPE="$( ( awk '/runs=/ { printf  "%s %s %s", $2 , $3 , $4}' specifs.txt ) )"
+MPIDCI="$( ( awk '/mpis=/ { printf  "%s ", $2}' specifs.txt ) )"
+MPIDCJ="$( ( awk '/mpis=/ { printf  "%s ", $3}' specifs.txt ) )"
+MPIDCIJ="$( ( awk '/mpis=/ { printf  "%s ", $4}' specifs.txt ) )"
 VTIME=$( ( awk '/time=/ { print $2 }' specifs.txt ) )
 REF_TAG=$( (awk '/tagname=/ {print $2}' specifs.txt) )
@@ -372,5 +374,4 @@
 echo " ############################                           " >> endjob.txt
 echo "                                                        " >> endjob.txt
-echo "                                                        " >> endjob.txt
 
 # ###############################
@@ -405,7 +406,23 @@
 echo "                                                        " >> endjob.txt
 
-# ###############################
-# ###############################
-# 0.III NEMO SOURCE FILES INFORMATION, i.e. revision & URL downloaded
+
+# ###############################
+# ###############################
+# 0.III NEMO MPI DECOMPOSITION USED
+# ###############################
+for runt in ${LRTYPE} ; do
+    if [ ${runt} = 'mpi' ] ; then
+        echo " #############################                               " >> endjob.txt
+        echo " NEMO MPI DECOMPOSITION USED                                 " >> endjob.txt
+        echo " #############################                               " >> endjob.txt
+        echo "                                                             " >> endjob.txt
+        echo "   jpni = ${MPIDCI} ; jpnj = ${MPIDCJ} ; jpnij = ${MPIDCIJ}  " >> endjob.txt
+        echo "                                                             " >> endjob.txt
+    fi
+done
+
+# ###############################
+# ###############################
+# 0.IV NEMO SOURCE FILES INFORMATION, i.e. revision & URL downloaded
 # ###############################
 echo " #############################                          " >> endjob.txt
@@ -416,5 +433,4 @@
 echo "   NEMO revision : ${REV_USE}                           " >> endjob.txt
 echo "                                                        " >> endjob.txt
-
 
 test -n "${TODO}"
Index: /trunk/NVTK/INSTALL/JOBS/lance_batch.ksh
===================================================================
--- /trunk/NVTK/INSTALL/JOBS/lance_batch.ksh	(revision 1573)
+++ /trunk/NVTK/INSTALL/JOBS/lance_batch.ksh	(revision 1574)
@@ -5,9 +5,10 @@
 # Contact  : nemo_st@locean-ipsl.upmc.fr
 #
-# INPUT ARGS: 8
+# INPUT ARGS: 9
 #     - CONF  : configuration name (ORCA2_LIM, GYRE ..)
 #     - MTIME : timing/no timing (timing or notiming)
 #     - JOBTOL: jobs to launch: all, long, 1_short or gtime
 #     - OWNEXP: name of the experience performed
+#     - PRC   : total number of processors
 #     - REFTAG: reference tag name to be compare to
 #     - USE_IOMPUT: true of false (default false)
@@ -59,8 +60,6 @@
 ##########################################################
 # IODIR     : directory where to get ORCA2_LIM_nemo_v3.1.tar 
-# PRC       : total number of processors which will be used
 ##########################################################
 IODIR=/u/rech/eee/reee512/NEMO/
-PRC=8
 TARGET=sx8brodie
 ##########################################################
@@ -72,8 +71,9 @@
 JOBTOL=$3
 OWNEXP=$4
-REFTAG=$5
-USE_IOMPUT=${6:-false}
-USE_IOSERVER=${7:-false}
-NB_PROCS_IOSERVER=${8:-0}
+PRC=$5
+REFTAG=$6
+USE_IOMPUT=${7:-false}
+USE_IOSERVER=${8:-false}
+NB_PROCS_IOSERVER=${9:-0}
 [ "${USE_IOMPUT}" = "false" ] && USE_IOSERVER=false
 [ "${USE_IOSERVER}" = "false" ] && NB_PROCS_IOSERVER=0
Index: /trunk/NVTK/INSTALL/ins_nvtk.ksh
===================================================================
--- /trunk/NVTK/INSTALL/ins_nvtk.ksh	(revision 1573)
+++ /trunk/NVTK/INSTALL/ins_nvtk.ksh	(revision 1574)
@@ -223,12 +223,9 @@
 echo '			'
 echo '			#############################################################'
-echo '             >>>>>>>>   Now set "by hand" the mpi domain decomposition indices jpni, '
-echo '                        jpnj & jpnij in par_oce.F90_keep files (keeping the "_keep" extension) '
-echo "                        in coherence with the ${DECOMP} total number of processors you just set "
-echo '                        Make this modification in the following directories:         '
+echo '             >>>>>>>>   Following configuration(s) can be used with NVTK:'
 ind=0
 while [ $ind -lt ${NBCFG} ]
 do
-echo "                        ../config/${CONF[${ind}]}/MY_SRC"
+echo "                        # ${CONF[${ind}]}"
 let ind=$ind+1
 done