Index: branches/devmercator2010/CONFIG/POMME/scripts/BB_make
===================================================================
--- branches/devmercator2010/CONFIG/POMME/scripts/BB_make	(revision 2069)
+++ branches/devmercator2010/CONFIG/POMME/scripts/BB_make	(revision 2072)
@@ -7,6 +7,4 @@
 #          Check your compilers option in consequence when using real F95 compilers
 
-F_O += -I$(MODDIR) -I$(MODDIR)/oce -I$(NCDF_INC) $(USER_INC)
-L_X = $(L_O)
 #-Q- platine # Compiler options NEMO (CCRT Itanium Bull) 
 #-Q- platine F_O = -O3 -i4 -r8 -module $(MODDIR)/oce -I$(MODDIR) -I$(MODDIR)/oce -I$(NCDF_INC) $(USER_INC) 
@@ -24,10 +22,10 @@
 #-Q- sxdkrz  F_O =  -f2003 nocbind -ew -sx6 -ftrace -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh -O overlap" -Wf"-pvctl noassume loopcnt=10000" -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC) $(USER_INC)
 #-Q- sxdkrz  L_X = $(L_O) -ftrace
-#-Q- es2  # Compiler options for NEMO (Earth Simulator)
-#-Q- es2  # for super perfs!
-#-Q- es2  # F_O = -f2003 nocbind $(FTRACE) -pi nest=5 line=10000 expin=Fmpplib.F -Wf,-A idbl4 -C hopt -Wf"-P nh -O overlap" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC) $(USER_INC)
-#-Q- es2  # regular options!
-#-Q- es2  F_O = -f2003 nocbind $(FTRACE) -Wf,-A idbl4 -C vopt -P stack -Wf"-P nh -O overlap" -Wf,-pvctl noassume loopcnt=10000 -L transform -Wf,-pvctl nomsg -Wf"-O nomsg" -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC) $(USER_INC)
-#-Q- es2  L_X = $(L_O)
+#-Q- eshpux  # Compiler options for NEMO (Earth Simulator)
+#-Q- eshpux  # for super perfs!
+#-Q- eshpux  # F_O = -f2003 nocbind $(FTRACE) -pi nest=5 line=10000 expin=Fmpplib.F -Wf,-A idbl4 -C hopt -Wf"-P nh -O overlap" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC) $(USER_INC)
+#-Q- eshpux  # regular options!
+#-Q- eshpux  F_O = -f2003 nocbind $(FTRACE) -Wf,-A idbl4 -C vopt -P stack -Wf"-P nh -O overlap" -Wf,-pvctl noassume loopcnt=10000 -L transform -Wf,-pvctl nomsg -Wf"-O nomsg" -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC) $(USER_INC)
+#-Q- eshpux  L_X = $(L_O)
 #-Q- linux  # Compiler options for NEMO (pgf version)
 #-Q- linux  F_O = -Mlist -O3 -byteswapio -r8  -I $(MODDIR) -I$(MODDIR)/oce -I $(NCDF_INC) $(USER_INC)
@@ -64,5 +62,5 @@
 #-Q- sx8brodie	PREF=i.
 #-Q- sxdkrz	PREF=i.
-#-Q- es2	PREF=i.
+#-Q- eshpux	PREF=i.
 
 # add suffix to P_P
@@ -103,5 +101,5 @@
 
 #check key compatibility
-keycompat=$(if $(word 2, $(findstring $1,$(P_P)) $(findstring $2,$(P_P))),$(error $1 and $2 NOT compatible))
+keycompat=$(if $(and $(findstring $1,$(P_P)),$(findstring $2,$(P_P))),$(error $1 and $2 NOT compatible))
 
 KEY_LIST = \
@@ -432,5 +430,5 @@
 
 # Agrif library and conv
-libagrif :
+libagrif :  $(call keycompat,key_iomput,key_agrif)
 ifeq ($(AGRIF),use)
 	@( if [ ! -d OPAFILES ]; then mkdir OPAFILES; fi )
@@ -458,5 +456,5 @@
 #-Q- sx8brodie		-R2 \
 #-Q- sxdkrz		-R2 \
-#-Q- es2		-R2 \
+#-Q- eshpux		-R2 \
 #-Q- aix6		-qsource \
 #-Q- aix		-qsource \
@@ -464,5 +462,5 @@
 	   OPAFILES/$*.F90 || { mv $(PREF).L $(TMP) ; false ; exit ; }
 #-Q- sxdkrz		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
-#-Q- es2			@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
+#-Q- eshpux			@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
 endif
 
@@ -478,5 +476,5 @@
 .PRECIOUS : $(MODEL_LIB)
 #-Q- sxdkrz .PRECIOUS : $(SXMODEL_LIB)
-#-Q- es2 .PRECIOUS : $(SXMODEL_LIB)
+#-Q- eshpux .PRECIOUS : $(SXMODEL_LIB)
 
 # library dependancies
@@ -497,5 +495,5 @@
 #-Q- sx8brodie		-R2 \
 #-Q- sxdkrz		-R2 \
-#-Q- es2		-R2 \
+#-Q- eshpux		-R2 \
 #-Q- aix		-qsource \
 #-Q- aix6		-qsource \
@@ -503,5 +501,5 @@
 		$*.f90 || { if [ -f $(PREF)$*.L ] ; then mv $(PREF)$*.L $(TMP) ; fi ; false ; exit ; }
 #-Q- sxdkrz		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
-#-Q- es2		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
+#-Q- eshpux		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
 		@$(A_C) $(MODEL_LIB) $*.o  > /dev/null
 		@$(RM) $*.[of]
@@ -533,5 +531,5 @@
 #-Q- sx8brodie		-R2 \
 #-Q- sxdkrz		-R2 \
-#-Q- es2		-R2 \
+#-Q- eshpux		-R2 \
 #-Q- aix		-qsource \
 #-Q- aix6		-qsource \
@@ -545,5 +543,5 @@
 #-Q- sx8brodie		-R2 \
 #-Q- sxdkrz		-R2 \
-#-Q- es2		-R2 \
+#-Q- eshpux		-R2 \
 #-Q- aix		-qsource \
 #-Q- aix6		-qsource \
@@ -552,5 +550,5 @@
 endif
 #-Q- sxdkrz		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
-#-Q- es2		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
+#-Q- eshpux		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
 		@$(A_C) $(MODEL_LIB) $*.o  > /dev/null
 		@$(RM) $*.[of]
@@ -1197,27 +1195,13 @@
 	diaar5.F90
 $(MODEL_LIB)(diadimg.o) :	\
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(iom.o) \
-	$(MODEL_LIB)(lib_print.o) \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(prtctl.o) \
-	$(MODEL_LIB)(restart.o) \
-	dom_oce.F90 \
-	in_out_manager.F90 \
-	iom.F90 \
-	lib_print.f90 \
-	par_kind.F90 \
-	par_oce.F90 \
-	phycst.F90 \
-	prtctl.F90 \
-	restart.F90 \
-	$(MODEL_LIB)(daymod.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(oce.o) \
-	daymod.F90 \
+	$(MODEL_LIB)(lib_print.o) \
+	$(MODEL_LIB)(par_kind.o) \
+	$(MODEL_LIB)(par_oce.o) \
+	lib_print.f90 \
+	par_kind.F90 \
+	par_oce.F90 \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(oce.o) \
 	dom_oce.F90 \
 	in_out_manager.F90 \
@@ -1374,4 +1358,5 @@
 	phycst.F90 \
 	$(IOIPSL_LIB) \
+	KEY_CPP \
 	dianam.F90
 $(MODEL_LIB)(diaptr.o) :	\
@@ -1434,5 +1419,4 @@
 	diaptr.F90
 $(MODEL_LIB)(diawri.o) :	\
-	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dianam.o) \
 	$(MODEL_LIB)(dom_ice_2.o) \
@@ -1462,5 +1446,4 @@
 	$(MODEL_LIB)(sbcrnf.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	daymod.F90 \
 	dianam.F90 \
 	dom_ice_2.F90 \
@@ -4611,4 +4594,5 @@
 	in_out_manager.F90 \
 	lbcnfd.F90 \
+	$(AGRIF_LIB) \
 	KEY_CPP \
 	lib_mpp.F90
@@ -5325,5 +5309,4 @@
 	$(MODEL_LIB)(limistate_2.o) \
 	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(sbc_oce.o) \
 	dom_ice_2.F90 \
 	dom_oce.F90 \
@@ -5336,5 +5319,4 @@
 	limistate_2.F90 \
 	phycst.F90 \
-	sbc_oce.F90 \
 	vectopt_loop_substitute.h90 \
 	KEY_CPP \
@@ -8014,5 +7996,4 @@
 	$(MODEL_LIB)(lib_print.o) \
 	$(MODEL_LIB)(limwri_2.o) \
-	$(MODEL_LIB)(obc_oce.o) \
 	$(MODEL_LIB)(obctra.o) \
 	$(MODEL_LIB)(oce.o) \
@@ -8086,5 +8067,4 @@
 	lib_print.f90 \
 	limwri_2.F90 \
-	obc_oce.F90 \
 	obctra.F90 \
 	oce.F90 \
@@ -9640,5 +9620,4 @@
 	$(MODEL_LIB)(lib_print.o) \
 	$(MODEL_LIB)(obc_oce.o) \
-	$(MODEL_LIB)(obc_par.o) \
 	$(MODEL_LIB)(oce.o) \
 	$(MODEL_LIB)(par_kind.o) \
@@ -9665,5 +9644,4 @@
 	lib_print.f90 \
 	obc_oce.F90 \
-	obc_par.F90 \
 	oce.F90 \
 	par_kind.F90 \
@@ -9690,5 +9668,4 @@
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(lbclnk.o) \
-	$(MODEL_LIB)(obc_oce.o) \
 	$(MODEL_LIB)(obctra.o) \
 	$(MODEL_LIB)(oce.o) \
@@ -9707,5 +9684,4 @@
 	in_out_manager.F90 \
 	lbclnk.F90 \
-	obc_oce.F90 \
 	obctra.F90 \
 	oce.F90 \
@@ -10196,5 +10172,4 @@
 $(MODEL_LIB)(trdmld.o) :	\
 	$(MODEL_LIB)(c1d.o) \
-	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(eosbn2.o) \
@@ -10222,5 +10197,4 @@
 	$(MODEL_LIB)(zpshde.o) \
 	c1d.F90 \
-	daymod.F90 \
 	dom_oce.F90 \
 	eosbn2.F90 \